import pymodbus
from pymodbus.pdu import ModbusRequest
from pymodbus.client.sync import ModbusSerialClient as ModbusClient #initialize a serial RTU client instance
from pymodbus.transaction import ModbusRtuFramer
from pymodbus.constants import Endian
from pymodbus.payload import BinaryPayloadDecoder
import time

slave = 1
reg = 1000     #address 31001
ln = 20

try:
        client = ModbusClient(method='rtu', port='COM16', timeout=3, stopbits = 1, bytesize = 8, parity = 'N', baudrate = 9600)
except Exception as e:
        print(e)

while True:
        try:
                if client.connect() :
                        result = client.read_input_registers(reg,ln,unit=slave)
                        print (result)
                        print (result.getRegister(0))
                        print (result.getRegister(6))
                        print (result.getRegister(12))
                        print (result.getRegister(18))
                        client.close()
                else:
                        print("Connection Error")
        except Exception as e:
                print(e)
        time.sleep(1)


#Input Register
#CH1 = 31001
#CH2 = 31007
#CH3 = 31013
#CH4 = 31019
